grammar Calculator;

/** PARSER */
line : expr EOF ;
expr
    : '(' expr ')'          # parenExpr
    | '-' expr              # negExpr
    | expr ('*'|'/') expr   # multOrDiv
    | expr ('+'|'-') expr   # addOrSubtract
    | ID                    # identifier
    | FLOAT                 # float ;

/** LEXER */

WS : [ \t\n\r]+ -> skip ;
FLOAT
    : DIGIT+ '.' DIGIT* EXPONENT?
    | '.' DIGIT+ EXPONENT?
    | DIGIT+ EXPONENT? ;
ID : LETTER (LETTER | DIGIT)* ;
fragment DIGIT : '0'..'9';
fragment LETTER : 'a'..'z' | 'A'..'Z';
fragment EXPONENT : ('e'|'E') ('+'|'-')? DIGIT+ ;
